#ifndef FMUS_IO_H
#define FMUS_IO_H

#include "fmustypes.h"

typedef struct fmus_ctx fmus_t;

fmus_err_t fmus_write_file (fmus_t *fmus, char *filename, u8_t overwrite,
                            u8_t *payload, size_t len, u8_t mkpath);
FILE *fmus_fopen (u32_t terminal_width, char *filename, char *mode);
fmus_err_t fmus_stat (fmus_t *fmus, char *filename, fmus_stat_t *stat_out);
fmus_err_t fmus_read_file (fmus_t *fmus, char *filename,
                           u8_t **payload_out, size_t *len_out);
fmus_err_t fmus_getpath (fmus_t *fmus, char *path, char **output);
fmus_err_t fread_fully(//fmus_t *fmus,
                       u32_t terminal_width,
                       u8_t *buf,
                       size_t size,
                       FILE *f);
fmus_err_t fwrite_fully(fmus_t *fmus,
                        u8_t *buf,
                        size_t size,
                        char *filename,
                        FILE *f);
fmus_err_t mkdir_for_file (fmus_t *fmus, char *filename);
fmus_err_t get_default_cfgfile_path (fmus_t *fmus, char **path_out);
u64_t read_u64_bigendian (u8_t *buf);
u32_t read_u32_bigendian (u8_t *buf);
s32_t read_s32_bigendian (u8_t *buf);
u16_t read_u16_bigendian (u8_t *buf);
float read_float_bigendian (u8_t *buf);
void write_u16_bigendian(u8_t *buf, u16_t x);
void write_u32_bigendian(u8_t *buf, u32_t x);
void write_s32_bigendian(u8_t *buf, s32_t x);
void write_u64_bigendian(u8_t *buf, u64_t x);

#endif
