#ifndef MPFONT_H
#define MPFONT_H

#include "fmustypes.h"

typedef struct fmus_mpfont fmus_mpfont_t;
typedef struct fmus_ctx fmus_t;

fmus_err_t fmus_load_mpfont (fmus_t *fmus, char *filename, u8_t load_kerning);
fmus_err_t fmus_parse_mpfont (fmus_t *fmus, u8_t do_kerning, u8_t *buf, size_t len);
fmus_err_t export_mpfont(fmus_t *fmus,
                       fmus_mpfont_t *mpfont,
                       u8_t do_kerning,
                       u8_t **font_out,
                       size_t *font_len_out);
void print_mpfont(fmus_t *fmus,
                  fmus_mpfont_t *mpfont,
                  char *mpfont_filename,
                  u8_t verbose);
void init_mpfont (fmus_mpfont_t *mpfont);

typedef struct fmus_mpfont {
  
  u32_t version;
  s32_t line_height;
  u32_t vert_offset;
  s32_t line_margin;
  float font_size;
  char *name;
  u64_t txid_64;
  //u64_t txid;
  u32_t tx_fmt;
  u32_t num_glyphs;
  
  u32_t unk1_32;
  u8_t unk2_8;
  u8_t unk3_8;
  u32_t unk4_32;
  
  u32_t kerning_entries;
  
} fmus_mpfont_t;

#endif // MPFONT_H
